package exnihilocreatio.blocks;

import exnihilocreatio.ExNihiloCreatio;
import exnihilocreatio.config.ModConfig;
import exnihilocreatio.items.tools.ICrook;
import exnihilocreatio.tiles.TileInfestedLeaves;
import exnihilocreatio.util.Data;
import exnihilocreatio.util.Util;
import mcjty.theoneprobe.api.IProbeHitData;
import mcjty.theoneprobe.api.IProbeInfo;
import mcjty.theoneprobe.api.ProbeMode;
import net.minecraft.block.Block;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.Items;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.EnumBlockRenderType;
import net.minecraft.util.NonNullList;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;

import javax.annotation.Nonnull;
import java.util.Random;

import exnihilocreatio.blocks.BlockInfestingLeaves.InfestedType;

public class BlockInfestedLeaves extends BlockInfestingLeaves {

    public BlockInfestedLeaves() {
        super(InfestedType.INFESTED);
        this.func_149663_c("block_infested_leaves");
        this.setRegistryName("block_infested_leaves");
        this.func_149647_a(ExNihiloCreatio.tabExNihilo);
        Data.BLOCKS.add(this);
        this.func_180632_j(
                this.field_176227_L.func_177621_b().func_177226_a(field_176236_b, false).func_177226_a(field_176237_a, false));
    }

    @Override
    @Nonnull
    @Deprecated
    public EnumBlockRenderType func_149645_b(IBlockState state) {
        return EnumBlockRenderType.MODEL;
    }

    @Override
    public void func_180645_a(@Nonnull World world, @Nonnull BlockPos pos, @Nonnull IBlockState state, @Nonnull Random rand) {
        this.func_180650_b(world, pos, state, rand);
        if (!world.field_72995_K) {
            if (state.func_177229_b(NEARBYLEAVES)) {
                NonNullList<BlockPos> nearbyLeaves = Util.getNearbyLeaves(world, pos);
                if (nearbyLeaves.isEmpty()) {
                    world.func_180501_a(pos, state.func_177226_a(NEARBYLEAVES, false), 7);
                } else {
                    nearbyLeaves.stream().filter(leaves -> rand.nextFloat() <= ModConfig.infested_leaves.leavesSpreadChanceFloat).findAny().ifPresent(blockPos -> BlockInfestingLeaves.infestLeafBlock(world, world.func_180495_p(blockPos), blockPos));
                }
            }
        }
    }

    @Override
    public void func_189540_a(IBlockState state, World worldIn, BlockPos pos, Block blockIn, BlockPos fromPos) {
        if (!worldIn.field_72995_K && Util.isLeaves(worldIn.func_180495_p(fromPos)))
            worldIn.func_180501_a(pos, state.func_177226_a(NEARBYLEAVES, true), 7);
        super.func_189540_a(state, worldIn, pos, blockIn, fromPos);
    }

    public void func_176235_d(World worldIn, @Nonnull BlockPos pos) {
        if (worldIn.field_73012_v.nextInt(3) == 0) {
            if (worldIn.field_73012_v.nextFloat() < ModConfig.crooking.stringChance / 4.0d) {
                func_180635_a(worldIn, pos, new ItemStack(Items.field_151007_F));
            }
        }
        super.func_176235_d(worldIn, pos);
    }

    @Override
    public TileEntity func_149915_a(@Nonnull World worldIn, int meta) {
        return new TileInfestedLeaves();
    }


    @Override
    public void func_176208_a(World world, BlockPos pos, IBlockState state, EntityPlayer player) {
        if (!world.field_72995_K && !player.func_184812_l_()) {
            TileEntity tile = world.func_175625_s(pos);

            if (tile != null) {
                if (tile instanceof TileInfestedLeaves) {
                    TileInfestedLeaves leaves = (TileInfestedLeaves) tile;

                    if (!player.func_184614_ca().func_190926_b()
                            && player.func_184614_ca().func_77973_b() instanceof ICrook) {
                        Util.dropItemInWorld(leaves, player, new ItemStack(Items.field_151007_F, 1, 0), 0.02f);
                    } else if (world.field_73012_v.nextFloat() < ModConfig.crooking.stringChance / 4.0d) {
                        Util.dropItemInWorld(leaves, player, new ItemStack(Items.field_151007_F, 1, 0), 0.02f);

                    }
                }

                world.func_175713_t(pos);
            }
        }
    }

    @Override
    public void addProbeInfo(ProbeMode mode, IProbeInfo probeInfo, EntityPlayer player, World world,
                             IBlockState blockState, IProbeHitData data) {
        probeInfo.text("Progress: Done");
    }


}
