package exnihilocreatio.tiles;

import exnihilocreatio.rotationalPower.CapabilityRotationalMember;
import exnihilocreatio.rotationalPower.IRotationalPowerProvider;
import net.minecraft.block.BlockLiquid;
import net.minecraft.block.state.IBlockState;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.ITickable;
import net.minecraftforge.common.capabilities.Capability;
import net.minecraftforge.fluids.IFluidBlock;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;

public class TileWaterwheel extends BaseTileEntity implements ITickable, IRotationalPowerProvider {
    public static final float ROTATION_PER_WHEEL = 0.5F;

    public float rotationValue = 0;
    public float perTickRotationOwn = 0F;
    public float perTickEffective = 0F;

    public EnumFacing facing = EnumFacing.NORTH;

    public boolean canTurn = true;

    private int counter = -1;

    @Override
    public void func_73660_a() {
        counter++;
        if (counter > 0 && counter % 10 == 0) {
            IBlockState left;
            IBlockState right;

            switch (facing) {
                case WEST:
                case EAST:
                    left = field_145850_b.func_180495_p(field_174879_c.func_177982_a(0, 0, -1));
                    right = field_145850_b.func_180495_p(field_174879_c.func_177982_a(0, 0, 1));
                    break;
                case NORTH:
                case SOUTH:
                default: // Will never happen but fuck you intelliJ errors
                    left = field_145850_b.func_180495_p(field_174879_c.func_177982_a(-1, 0, 0));
                    right = field_145850_b.func_180495_p(field_174879_c.func_177982_a(1, 0, 0));
                    break;
            }

            // boolean lIsWater = left.getBlock() == Blocks.WATER || left.getBlock() == ModFluids.blockWitchwater;
            // boolean rIsWater = right.getBlock() == Blocks.WATER || right.getBlock() == ModFluids.blockWitchwater;

            boolean lIsWater = left.func_177230_c() instanceof BlockLiquid || left.func_177230_c() instanceof IFluidBlock;
            boolean rIsWater = right.func_177230_c() instanceof BlockLiquid || right.func_177230_c() instanceof IFluidBlock;

            perTickRotationOwn = 0F;
            if (lIsWater) {
                perTickRotationOwn += ROTATION_PER_WHEEL;
            }

            if (rIsWater) {
                perTickRotationOwn -= ROTATION_PER_WHEEL;
            }

            float lastPerTickEffective = perTickEffective;
            perTickEffective = calcEffectivePerTickRotation(field_145850_b, field_174879_c, facing);

            if (lastPerTickEffective != perTickEffective) {
                func_70296_d();
            }
            counter = 0;
        }

        if (field_145850_b.field_72995_K) {
            rotationValue += perTickEffective;
        }
    }


    @Override
    @Nonnull
    public NBTTagCompound func_189515_b(NBTTagCompound tag) {
        if (facing != null)
            tag.func_74778_a("facing", facing.func_176610_l());
        tag.func_74776_a("rot", rotationValue);

        return super.func_189515_b(tag);
    }

    @Override
    public void func_145839_a(NBTTagCompound tag) {
        super.func_145839_a(tag);

        if (tag.func_74764_b("facing"))
            facing = EnumFacing.func_176739_a(tag.func_74779_i("facing"));
        if (tag.func_74764_b("rot"))
            rotationValue = tag.func_74760_g("rot");
    }

    @Override
    public float getOwnRotation() {
        return perTickRotationOwn;
    }

    @Override
    public float getEffectivePerTickRotation(EnumFacing direction) {
        if (facing == direction) {
            return perTickEffective;
        } else {
            return 0;
        }
    }

    @Override
    public boolean hasCapability(@Nonnull Capability<?> capability, @Nullable EnumFacing facing) {
        return capability == CapabilityRotationalMember.ROTIONAL_MEMBER && facing == this.facing || super.hasCapability(capability, facing);
    }

    @Nullable
    @Override
    public <T> T getCapability(@Nonnull Capability<T> capability, @Nullable EnumFacing facing) {
        if (capability == CapabilityRotationalMember.ROTIONAL_MEMBER && facing == this.facing)
            return CapabilityRotationalMember.ROTIONAL_MEMBER.cast(this);
        return super.getCapability(capability, facing);
    }

    @Override
    public void setEffectivePerTickRotation(float rotation) {
        perTickEffective = rotation;
    }
}
